#include <LCDHC595.h>

#define SIN_PIN 5
#define STR_PIN 6
#define CLK_PIN 7

LCDHC595 lcd = LCDHC595(SIN_PIN,STR_PIN,CLK_PIN);

/***** Digital wind check voltage ******/
int wind20 = 11;
int wind16 = 10;
int wind12 = 9;
int wind5 = 8;

/****** Analog ******/
int batt = 5;
int adc = 4;
int adc2 = 3;

/***** digital charge ******/
int Dch1 = 4;
int Dch2 = 3;
int Dch3 = 2;

int dwin,vwind,wind;
float a,b,vol,c1,c2,isen,isen2;
float d = 510;

void setup()
{
  Serial.begin(19200);
  Serial.println("  WIND CHARGER  ");
  lcd.Initial();
  lcd.Print("  WIND CHARGER  ");
  delay(2000);
  lcd.ClearScreen();
  
/************* chk wind voltage ***************/  
  pinMode(wind20,INPUT);
  pinMode(wind16,INPUT);
  pinMode(wind12,INPUT);
  pinMode(wind5,INPUT);
/****************** Setup Port ****************/  
  pinMode(Dch1,OUTPUT);
  pinMode(Dch2,OUTPUT);
  pinMode(Dch3,OUTPUT);
  delay(100);
  
  if ((digitalRead(wind20)==HIGH)&&(digitalRead(wind16)==HIGH)&&(digitalRead(wind12)==HIGH)&&(digitalRead(wind5)==HIGH))
  {
    lcd.SetCursor(0x00);
    lcd.Print("  Wind VOLTAGE  ");
    lcd.SetCursor(0x40) ;
    lcd.Print("No Wind Connect ");
    delay(2000);
    lcd.ClearScreen();
  }
  else if ((digitalRead(wind20)==HIGH)&&(digitalRead(wind16)==HIGH)&&(digitalRead(wind12)==HIGH)&&(digitalRead(wind5)==LOW))
  {
    lcd.SetCursor(0x00);
    lcd.Print("  Wind VOLTAGE  ");
    lcd.SetCursor(0x40) ;
    lcd.Print(" Vwind = 6~13.8V");
    delay(2000);
    lcd.ClearScreen();
  }
  else if ((digitalRead(wind20)==HIGH)&&(digitalRead(wind16)==HIGH)&&(digitalRead(wind12)==LOW)&&(digitalRead(wind5)==LOW))
  {
    lcd.SetCursor(0x00);
    lcd.Print("  Wind VOLTAGE  ");
    lcd.SetCursor(0x40) ;
    lcd.Print("Vwind = 13.8~16V");
    delay(2000);
    lcd.ClearScreen();
  }
  else if ((digitalRead(wind20)==HIGH)&&(digitalRead(wind16)==LOW)&&(digitalRead(wind12)==LOW)&&(digitalRead(wind5)==LOW))
  {
    lcd.SetCursor(0x00);
    lcd.Print("  Wind VOLTAGE  ");
    lcd.SetCursor(0x40) ;
    lcd.Print(" Vwind = 16~19V ");
    delay(2000);
    lcd.ClearScreen();
  }
  else if ((digitalRead(wind20)==LOW)&&(digitalRead(wind16)==LOW)&&(digitalRead(wind12)==LOW)&&(digitalRead(wind5)==LOW))
  {
    lcd.SetCursor(0x00);
    lcd.Print("  Wind VOLTAGE  ");
    lcd.SetCursor(0x40) ;
    lcd.Print(" Vwind = >20V ");
    delay(2000);
    lcd.ClearScreen();
  }
}
/*********************************************** MAIN *************************************************************/  
void loop()
{
  Rewind:
  if(digitalRead(wind12)==LOW)                                    //check voltage windturbine if Vwind higher than 13.8v 
  {
    Serial.println(" Winturbine charge ON ");
    lcd.SetCursor(0x00);
    lcd.Print("   CHARGER ON   "); 
    delay(1000);
    
    vol = analogRead(batt);                                        //Read analog voltage batt1
    if(vol>=576)                                                   // if batt1>= 12V (576) on charge batt 2
    {
      RepeatChargeB2:
      Serial.println(" ON Charge Batt2 ");
      digitalWrite(Dch1, LOW);
      digitalWrite(Dch2, HIGH);
      digitalWrite(Dch3, HIGH);
      delay(1000);    
      
      c2 = analogRead(adc2);                                        //Read current batt2
      isen2 = (c2-d)*50/1023;
      
      lcd.ClearScreen();
      lcd.SetCursor(0x00);
      lcd.Print(" ON CHARGE BATT2");                                // show display status charge batt 2
      lcd.SetCursor(0x40) ;
      lcd.Print("i_batt2 =       ");
      lcd.SetCursor(0x4A);
      lcdPrintFloat(isen2,2);                                       // show current batt2
      delay(1000);
      chkCurBat2();
      
      if(c2>=517)                                                  //if current batt2 more than 0.34mA
      {
        Serial.println(" ON Check Batt2 ");
        delay(500);
        goto RepeatChargeB2;                                        
      }
    
  
      else                                                          //if current batt2 lower than 0.34mA
      {
        RepeatLoad:
        chkWind();                                                  //check voltage windturbine if Vwind higher than 13.8v
        if(wind==2)                                                 //check condition voltage windturbine low
        {
          goto Rewind;                                              
        }
         
        Serial.println(" ON Charge LOAD ");
        lcd.ClearScreen();
        lcd.SetCursor(0x00);
        lcd.Print(" ON Charge LOAD ");
        
        digitalWrite(Dch1, LOW);                                    //On charge Load
        digitalWrite(Dch2, LOW);
        digitalWrite(Dch3, LOW);
        delay(1000);
        
        vol = analogRead(batt);                                     //Read analog voltage batt1
        if(vol<=576)                                                //check batt1 if batt1 <=11V(528) repeat charge batt1
        {
          delay(500);
          goto RepeatChargeB1;
        }
        else                                                        //if batt1 more than 11V repeat charge Load
        {
          Serial.println(" ON Check BATT1 ");
          delay(500);
          goto RepeatLoad;
        }        
      }       
    }
    else                                                            //if batt1 <= 12V (576) on charge batt1
    {
      RepeatChargeB1:
      Serial.println(" ON Charge Batt1 ");
      digitalWrite(Dch1, HIGH);
      digitalWrite(Dch2, LOW);
      digitalWrite(Dch3, HIGH);
      delay(1000);
      
      c1 = analogRead(adc);                                         //Read current batt1
      vol = analogRead(batt);                                       //Read voltage batt1
    
      a = (vol*5)/1023;
      b = a*4.26;
      isen = (c1-d)*50/1023; 
    
      lcd.SetCursor(0x00);
      lcd.Print("v_batt1 =       ");                                //Show Vbatt1
      lcd.SetCursor(0x0A);
      lcdPrintFloat(b,2); 
      lcd.SetCursor(0x40) ;
      lcd.Print("i_batt1 =       ");                                //Show c1
      lcd.SetCursor(0x4A);
      lcdPrintFloat(isen,2);   
      delay(1000);
      
      if((vol<=710)&&(c1>=517))                                     //check batt1 full if voltage lower than 14.8V and c1>=0.34mA
      {
        Serial.println(" On Charge Batt1 & check batt full ");      //Repeat Charge batt1
        chkCurrent();
        goto RepeatChargeB1;
      }
      else                                                          //if batt1 full off batt1
      {
        digitalWrite(Dch1, LOW);
        digitalWrite(Dch2, LOW);
        digitalWrite(Dch3, HIGH);
        delay(1000);
      }
    }
  }
  else
  {
    Serial.println(" Winturbine charge OFF ");
    lcd.ClearScreen();
    lcd.SetCursor(0x00);
    lcd.Print(" OFF Charge Batt "); 
    
    digitalWrite(Dch1, LOW);
    digitalWrite(Dch2, LOW);
    digitalWrite(Dch3, HIGH);
    delay(1000);
  }
}

/************************* lcdPrintFloat *******************************************/
void lcdPrintFloat( float val, byte precision){
  // prints val on a ver 0012 text lcd with number of decimal places determine by precision
  // precision is a number from 0 to 6 indicating the desired decimial places
  // example: lcdPrintFloat( 3.1415, 2); // prints 3.14 (two decimal places)

  if(val < 0.0){
    lcd.Print('-');
    val = -val;
  }

  lcd.Print ((long)val);  //prints the integral part
  if( precision > 0) {
    lcd.Print("."); // print the decimal point
    unsigned long frac;
    unsigned long mult = 1;
    byte padding = precision -1;
    while(precision--)
  mult *=10;

    if(val >= 0)
 frac = (val - int(val)) * mult;
    else
 frac = (int(val)- val ) * mult;
    unsigned long frac1 = frac;
    while( frac1 /= 10 )
 padding--;
    while(  padding--)
 lcd.Print("0");
    lcd.Print(frac,DEC) ;
  }
}
/****************** Check  VOLTAGE WIND ****************************/
void chkWind()
{
  if(digitalRead(wind12)==LOW)
  {
    wind=1;
  }
  else
  {
    Serial.println(" Winturbine charge OFF ");
    lcd.ClearScreen();
    lcd.SetCursor(0x00);
    lcd.Print(" OFF Charge Batt "); 
    
    digitalWrite(Dch1, LOW);
    digitalWrite(Dch2, LOW);
    digitalWrite(Dch3, HIGH);
    delay(1000);
    wind=2;
   }
}
/******************* Check Current Batt1 ****************************/
void chkCurrent()
{
  c1 = analogRead(adc);
  if(c1<=540)                                                            //Batt c1 <=1.5A
  {
    ;
  }
  else
  {
    RepeatC1C2:
    chkWind();
    Serial.println(" Winturbine charge ON Batt1,2 ");
    lcd.ClearScreen();
    lcd.SetCursor(0x00);
    lcd.Print(" ON Charge 2Batt"); 
    
    digitalWrite(Dch1, HIGH);
    digitalWrite(Dch2, HIGH);
    digitalWrite(Dch3, HIGH);
    delay(1000);
    
    
          c1 = analogRead(adc);
          isen = (c1-d)*50/1023;
          c2 = analogRead(adc2);
          isen2 = (c2-d)*50/1023;
        
          lcd.SetCursor(0x00);                                                  //Dispaly c1,c2
          lcd.Print("i_batt1 =       ");
          lcd.SetCursor(0x0A);
          lcdPrintFloat(isen,2); 
          lcd.SetCursor(0x40) ;
          lcd.Print("i_batt2 =       ");
          lcd.SetCursor(0x4A);
          lcdPrintFloat(isen2,2);
          delay(1000);
          
          if(c1>=522&&c2>510)                                                        //check current batt1 if more than 0.58mA 
          {
            delay(250);
            Serial.println(" Check Winturbine charge ON Batt1,2 ");
            goto RepeatC1C2;
          }
          else if(c2<510)
          {
            Serial.println(" Check Winturbine current c2 < 0mA ");
            digitalWrite(Dch1, HIGH);
            digitalWrite(Dch2, LOW);
            digitalWrite(Dch3, HIGH);
            delay(1000);
            
          }
          else                                                               //if current lower than 0.58mA
          {
            Serial.println(" OFF CHARGE BATT2 ");
            digitalWrite(Dch1, HIGH);
            digitalWrite(Dch2, LOW);
            digitalWrite(Dch3, HIGH);
            delay(1000);
          }
  }
}

/***************** Check Current batt2 ************************/
void chkCurBat2()
{
  if(c2<=540)                                                                 //Batt c2 <=1.5A                                                           
  {
    ;
  }
  else
  {
    RepeatC2LOAD:
    Serial.println(" Winturbine charge ON Batt2,Load ");
     
    digitalWrite(Dch1, LOW);
    digitalWrite(Dch2, HIGH);
    digitalWrite(Dch3, LOW);
    delay(1000);
    
    c2 = analogRead(adc2);
    isen2 = (c2-d)*50/1023;
    
    lcd.ClearScreen();
    lcd.SetCursor(0x00);
    lcd.Print("ON Current limit");
    lcd.SetCursor(0x40) ;
    lcd.Print("i_batt2 =       ");
    lcd.SetCursor(0x4A);
    lcdPrintFloat(isen2,2);
    
    if(c2>=530)                                                              //check current batt2 if more than 1A 
    {
      delay(250);
      Serial.println(" Check Current Limit ON Batt2 ");
      goto RepeatC2LOAD;
    }
    else                                                                    //if current2 lower than 1A
    {
      digitalWrite(Dch1, LOW);
      digitalWrite(Dch2, HIGH);
      digitalWrite(Dch3, HIGH);
      delay(1000);
    }
  }
}
    
  
